/* The main routine */

#define GLOBAL_VARS
#include "data.h"

/* print a set of arrays */
static int PrintSet(void) {
 static int is=0;
 if(t>=(timcalc/ntimes)*is) {OutSpatial(FILE_BODY,is,0);is++;}
 return is<=ntimes;
}

/* initialization (parameters reading and preparation) */
static int Initialize(void) {
 static char errmsg[4096];
 int ierr=0,warn=0;
 strcpy(errmsg,"");
 if(!ReadParams(CFGNAME)) {
  fprintf(stderr,"Default parameters substitution\n");
  InitParams();
 }
 WriteParams(TMPNAME);
 PrepareParams(&ierr,&warn,errmsg);
 if(ierr || warn) {
  OutErr(FILE_INIT,ERRNAME);
  OutErr(FILE_BODY,errmsg);
  OutErr(FILE_CLOSE,0);
 }
 else remove(ERRNAME);
 if(ierr) return 0;
#if defined(IS_TUTORIAL)
 if(warn) return 0;
#endif
 return 1;
}

static void FtempName(char *b) {
 strcpy(b,out_root);strcat(b,EXTEMP);
}

static void FspatName(char *b) {
 strcpy(b,out_root);strcat(b,EXSPAT);
}

/* test it */
int main(void) {
 static char buf[151];
 OutLog(FILE_INIT,0);
 if(!Initialize()) {
  fprintf(stderr,"Initialization failed, see error.log\n");
  return 1;
 }
 FirstStep();
 FtempName(buf);
 if(!OutTemporal(FILE_INIT,buf)) {
  fprintf(stderr,"Temporal output failed\n");
  return 1;
 }
 FspatName(buf);
 if(!OutSpatial(FILE_INIT,0,buf)) {
  fprintf(stderr,"Temporal output failed\n");
  return 1;
 }
 step=0;
 do {
#if defined(DEBUG)
  if(step%DBG_STEP==0) {
   OutSpatial(FILE_BODY,step,0);
   if(!OutTemporal(FILE_BODY,0)) {
    fprintf(stderr,"Temporal output failed\n");
    return 1;
   }
   OutScreen();
  }
  if(step>=DBG_MSTEP) break;
#else
  if(!PrintSet()) break;
  if(step%SCR_STEPS==0) OutScreen();
  if(step%TMP_STEPS==0) {
   if(!OutTemporal(FILE_BODY,0)) {
    fprintf(stderr,"Temporal output failed\n");
    return 1;
   }
  }
#endif
  ++step;NextStep();
 } while(1);
 OutTemporal(FILE_CLOSE,0);
 OutSpatial(FILE_CLOSE,0,0);
 OutLog(FILE_CLOSE,LOGNAME);
 return 0;
}

