/* Gases description & operations */

enum{FUEL,OXID,PROD,NEUT,EC};

Global double Wm[EC],Gm[EC],Cpm[EC],Cvm[EC],Hm[EC];
Global double Nust[EC],Csw[EC];

Global double Arrh,Tact,Tmed;

#define Rgas	8.314

/* Prepare the gas state */
extern void PrepareGas(double wox, double gox, double wfu, double gfu,
	double wpr, double gpr, double wnu, double gnu,
	double qr, double nuox, double arrh, double Tac, double Tme, 
	int *ierr, int *warn, char *errmsg);

/* Get thermodynamic data per mass */
extern void GetThermo(double *cp,double *cv,double *h0,double *Y);
/* Get mass shares by molar shares, visa versa */
extern void GetYbyC(double *Y,double *C);
extern void GetCbyY(double *C,double *Y);
/* Get pressure using state equation */
extern double Pressure(double T,double rho,double *Y);
/* Get density using state equation */
extern double Density(double T,double p,double *Y);
/* Get molar mass */
extern double MolarMass(double *Y);
/* Get T by E */
extern double TempbyE(double E,double *Y);

/* Arrhenius */
extern double Funarr1(double T);
extern double Funarr(double T);
extern double DLfunarr1(double T);
extern double Dfunarr(double T);

