/* utio.c - low-level io utilities */

#include <stdio.h>
#include <ctype.h>
#include <math.h>

/* read a word from an open file line, then shift file pointer to 
   the EOL or EOF */
int ReadWord(char *buffer, FILE *hnd) {
 int c;
 char *p;
 p=buffer;
 while((c=fgetc(hnd))!=EOF) {
  if(p==buffer) {
   if(isspace(c) && c!='\n') continue;
   else if(c=='\n') {*p=0;break;}
   *p=c;
  }
  else if(isspace(c)||c=='\n') {*p=0;break;}
  else *p=c;
  p++;
 }
 while(c!=EOF) {
  if(c=='\n') break;
  c=fgetc(hnd);
 }
 if(feof(hnd)) {*p=0;return EOF;}
 return p>buffer;
}

/* parse a word for an integer */
int GetInt(int *v,char *word) {
 return sscanf(word,"%d",v);
}

/* parse a word for a double */
int GetDbl(double *v,char *word) {
 return sscanf(word,"%lf",v);
}

/* parse a word for an unsigned */
int GetUint(unsigned *v,char *word) {
 return sscanf(word,"%u",v);
}
