/* utmath.h - low-level math utilities */

#define ATOL 1.e-12
#define RTOL 1.e-9

/* easy square root */
extern double e_sqrt(double x);

/* flux limiter functions */
enum{NOFLIM,MINMOD,VANLEER,SUPERBEE,KOREN,MCLIM,OSHER,OSPRE,
	UMIST,VANALBADA,SWEBY};
extern double FLimit(double a,double b,int name,double addpar);

/* Ausm + functions */
extern void AusmPlus(double m,double *map,double *pip);
extern void AusmMinus(double m,double *mam,double *pim);

/* condition is true when relative dv[k] is too high */
extern int islongstep(int m,double *dv,double *v);

/* linear system of 2 equations (Kramer rule) */
extern int LinSolve2(double *dv,double *mv);

/* linear system of n equations (Gauss method) */
extern int LinSolve(int n,double *dv,double *mv);

extern double Change(double *dv,double *va,int n);

