/* utmemo.c - memory allocation utilities */

#include <malloc.h>
#include "utmemo.h"

/* vector, ivector, matrix, imatrix allocation */

double *dvector(int size) {
 double *v=(double *)malloc(sizeof(double)*size);
 return v;
}

int *ivector(int size) {
 int *v=(int *)malloc(sizeof(int)*size);
 return v;
}


double **dmatrix(int rows,int cols) {
 int j;
 double **m=(double **)malloc(sizeof(double *)*rows);
 if(!m) return 0;
 for(j=0;j<rows;j++) {
  m[j]=(double *)malloc(sizeof(double)*cols);
  if(!m[j]) {fdmatrix(m,j);return 0;}
 }
 return m;
}

int **imatrix(int rows,int cols) {
 int j;
 int **m=(int **)malloc(sizeof(int *)*rows);
 if(!m) return 0;
 for(j=0;j<rows;j++) {
  m[j]=(int *)malloc(sizeof(int)*cols);
  if(!m[j]) {fimatrix(m,j);return 0;}
 }
 return m;
}


void fdvector(double *v) {free(v);}
void fivector(int *v) {free(v);}

void fdmatrix(double **m,int rows) {
 int k;
 if(!m) return;
 for(k=rows-1;k>=0;k--) free(m[k]);
 free(m);
}

void fimatrix(int **m,int rows) {
 int k;
 if(!m) return;
 for(k=rows-1;k>=0;k--) free(m[k]);
 free(m);
}


